"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _domLib = require("dom-lib");

var _moment = _interopRequireDefault(require("moment"));

var _utils = require("../utils");

var _MonthDropdownItem = _interopRequireDefault(require("./MonthDropdownItem"));

var _scrollTopAnimation = _interopRequireDefault(require("../utils/scrollTopAnimation"));

var minYear = 1950;
var blockHeight = 84;
var monthMap = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11];

var MonthDropdown =
/*#__PURE__*/
function (_React$PureComponent) {
  (0, _inheritsLoose2.default)(MonthDropdown, _React$PureComponent);

  function MonthDropdown() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$PureComponent.call.apply(_React$PureComponent, [this].concat(args)) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "scrollTo", function (date) {
      var year = date.year();
      var top = (year - _this.getStartYear()) * blockHeight;
      (0, _scrollTopAnimation.default)(_this.scroll, top, (0, _domLib.scrollTop)(_this.scroll) !== 0);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "scroll", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindScrollRef", function (ref) {
      _this.scroll = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "addPrefix", function (name) {
      return (0, _utils.prefix)(_this.props.classPrefix)(name);
    });
    return _this;
  }

  var _proto = MonthDropdown.prototype;

  _proto.componentDidMount = function componentDidMount() {
    this.updatePosition();
  };

  _proto.componentDidUpdate = function componentDidUpdate() {
    this.updatePosition();
  };

  _proto.getStartYear = function getStartYear() {
    var _this$props = this.props,
        date = _this$props.date,
        _this$props$limitStar = _this$props.limitStartYear,
        limitStartYear = _this$props$limitStar === void 0 ? 5 : _this$props$limitStar;
    var startYear = date.year() - limitStartYear;
    return Math.max(startYear, minYear);
  };

  _proto.updatePosition = function updatePosition(props) {
    var _ref = props || this.props,
        date = _ref.date;

    date && this.scrollTo(date);
  };

  _proto.renderBlock = function renderBlock() {
    var _this2 = this;

    var _this$props2 = this.props,
        date = _this$props2.date,
        onSelect = _this$props2.onSelect,
        limitEndYear = _this$props2.limitEndYear,
        disabledMonth = _this$props2.disabledMonth;
    var ret = [];
    var selectedMonth = date.month();
    var selectedYear = date.year();
    var startYear = this.getStartYear();
    var nextYear = 0;

    var _loop = function _loop(i) {
      var _classNames;

      nextYear = startYear + i;
      var isSelectedYear = nextYear === selectedYear;
      var titleClasses = (0, _classnames.default)(_this2.addPrefix('year'), (_classNames = {}, _classNames[_this2.addPrefix('year-active')] = isSelectedYear, _classNames));
      ret.push(React.createElement("div", {
        className: _this2.addPrefix('row'),
        key: i
      }, React.createElement("div", {
        className: titleClasses
      }, nextYear), React.createElement("div", {
        className: _this2.addPrefix('list')
      }, monthMap.map(function (i, month) {
        var disabled = disabledMonth && disabledMonth((0, _moment.default)().year(nextYear).month(month));
        return React.createElement(_MonthDropdownItem.default, {
          date: date,
          onSelect: onSelect,
          disabled: disabled,
          active: isSelectedYear && month === selectedMonth,
          key: month,
          month: month + 1,
          year: nextYear
        });
      }))));
    };

    for (var i = 0; i < 100 && nextYear < selectedYear + limitEndYear; i += 1) {
      _loop(i);
    }

    return ret;
  };

  _proto.render = function render() {
    var _this$props3 = this.props,
        classPrefix = _this$props3.classPrefix,
        className = _this$props3.className,
        rest = (0, _objectWithoutPropertiesLoose2.default)(_this$props3, ["classPrefix", "className"]);
    var classes = (0, _classnames.default)(classPrefix, className);
    var unhandled = (0, _utils.getUnhandledProps)(MonthDropdown, rest);
    return React.createElement("div", (0, _extends2.default)({}, unhandled, {
      className: classes
    }), React.createElement("div", {
      className: this.addPrefix('content')
    }, React.createElement("div", {
      className: this.addPrefix('scroll'),
      ref: this.bindScrollRef
    }, this.renderBlock())));
  };

  return MonthDropdown;
}(React.PureComponent);

(0, _defineProperty2.default)(MonthDropdown, "defaultProps", {
  show: false,
  limitStartYear: 5,
  limitEndYear: 5,
  date: (0, _moment.default)()
});
(0, _defineProperty2.default)(MonthDropdown, "handledProps", ["className", "classPrefix", "date", "disabledMonth", "limitEndYear", "limitStartYear", "onSelect", "show"]);
var enhance = (0, _utils.defaultProps)({
  classPrefix: 'calendar-month-dropdown'
});

var _default = enhance(MonthDropdown);

exports.default = _default;