"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _domLib = require("dom-lib");

var _utils = require("rsuite-utils/lib/utils");

var _constants = require("../utils/constants");

var INITIAL_PADDING = 12;
var PADDING = 16;

var TreeCheckNode =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(TreeCheckNode, _React$Component);

  function TreeCheckNode() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleTreeToggle", function (event) {
      var _this$props = _this.props,
          onTreeToggle = _this$props.onTreeToggle,
          layer = _this$props.layer,
          nodeData = _this$props.nodeData; // 异步加载数据自定义loading图标时，阻止原生冒泡，不触发 document.click

      if (event.nativeEvent && event.nativeEvent.stopImmediatePropagation) {
        event.nativeEvent.stopImmediatePropagation();
      }

      onTreeToggle && onTreeToggle(nodeData, layer, event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleSelect", function (event) {
      var _this$props2 = _this.props,
          classPrefix = _this$props2.classPrefix,
          onTreeToggle = _this$props2.onTreeToggle,
          onSelect = _this$props2.onSelect,
          hasChildren = _this$props2.hasChildren,
          layer = _this$props2.layer,
          disabled = _this$props2.disabled,
          disabledCheckbox = _this$props2.disabledCheckbox,
          nodeData = _this$props2.nodeData,
          checkState = _this$props2.checkState;

      if (disabled || disabledCheckbox) {
        return;
      } // 如果点击的是展开 icon 就 return


      if (event.target instanceof HTMLElement) {
        if ((0, _domLib.hasClass)(event.target.parentNode, classPrefix + "-node-expand-icon-wrapper")) {
          return;
        }
      }

      var isChecked = false;

      if (checkState === _constants.CHECK_STATE.UNCHECK || checkState === _constants.CHECK_STATE.INDETERMINATE) {
        isChecked = true;
      }

      if (checkState === _constants.CHECK_STATE.CHECK) {
        isChecked = false;
      }

      nodeData.check = isChecked;
      onSelect && onSelect(nodeData, layer, event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderIcon", function () {
      var _this$props3 = _this.props,
          onRenderTreeIcon = _this$props3.onRenderTreeIcon,
          hasChildren = _this$props3.hasChildren,
          nodeData = _this$props3.nodeData,
          classPrefix = _this$props3.classPrefix;
      var expandIcon = React.createElement("i", {
        className: classPrefix + "-node-expand-icon icon"
      });

      if (typeof onRenderTreeIcon === 'function') {
        var customIcon = onRenderTreeIcon(nodeData);
        expandIcon = customIcon !== null ? React.createElement("div", {
          className: classPrefix + "-custom-icon"
        }, customIcon) : expandIcon;
      }

      return hasChildren ? React.createElement("div", {
        role: "button",
        tabIndex: "-1",
        "data-ref": nodeData.refKey,
        className: classPrefix + "-node-expand-icon-wrapper",
        onClick: _this.handleTreeToggle
      }, expandIcon) : null;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "renderLabel", function () {
      var _this$props4 = _this.props,
          classPrefix = _this$props4.classPrefix,
          nodeData = _this$props4.nodeData,
          onRenderTreeNode = _this$props4.onRenderTreeNode,
          label = _this$props4.label,
          layer = _this$props4.layer,
          disabled = _this$props4.disabled,
          disabledCheckbox = _this$props4.disabledCheckbox;
      var addPrefix = (0, _utils.prefix)(classPrefix);
      var input = React.createElement("span", {
        className: addPrefix('input-wrapper')
      }, React.createElement("input", {
        className: addPrefix('input'),
        type: "checkbox",
        disabled: disabled,
        onChange: _this.handleSelect
      }), React.createElement("span", {
        className: addPrefix('inner')
      }));
      var custom = typeof onRenderTreeNode === 'function' ? onRenderTreeNode(nodeData) : label;
      return React.createElement("span", {
        role: "button",
        tabIndex: "-1",
        className: addPrefix('checknode-label'),
        title: label,
        "data-layer": layer,
        "data-key": nodeData.refKey,
        onClick: _this.handleSelect
      }, !disabledCheckbox ? input : null, custom);
    });
    return _this;
  }

  var _proto = TreeCheckNode.prototype;

  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
    return !(0, _utils.shallowEqual)(this.props, nextProps);
  };
  /**
   * 展开收缩节点
   */


  _proto.render = function render() {
    var _classNames;

    var _this$props5 = this.props,
        classPrefix = _this$props5.classPrefix,
        visible = _this$props5.visible,
        active = _this$props5.active,
        layer = _this$props5.layer,
        disabled = _this$props5.disabled,
        disabledCheckbox = _this$props5.disabledCheckbox,
        checkState = _this$props5.checkState;
    var addPrefix = (0, _utils.prefix)(classPrefix + "-node");
    var classes = (0, _classnames.default)(classPrefix + "-node", (_classNames = {
      'text-muted': disabled
    }, _classNames[addPrefix('indeterminate')] = checkState === _constants.CHECK_STATE.INDETERMINATE, _classNames[addPrefix('checked')] = checkState === _constants.CHECK_STATE.CHECK, _classNames[addPrefix('disabled')] = disabled, _classNames[addPrefix('active')] = active, _classNames[addPrefix('disabled-checkbox')] = disabledCheckbox, _classNames));
    var styles = {
      paddingLeft: layer * PADDING + INITIAL_PADDING
    };
    return visible ? React.createElement("div", {
      style: styles,
      className: classes
    }, this.renderIcon(), this.renderLabel()) : null;
  };

  return TreeCheckNode;
}(React.Component);

(0, _defineProperty2.default)(TreeCheckNode, "defaultProps", {
  visible: true
});
(0, _defineProperty2.default)(TreeCheckNode, "handledProps", ["active", "checkState", "classPrefix", "disabled", "disabledCheckbox", "hasChildren", "label", "layer", "nodeData", "onRenderTreeIcon", "onRenderTreeNode", "onSelect", "onTreeToggle", "value", "visible"]);
var _default = TreeCheckNode;
exports.default = _default;