"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _pick2 = _interopRequireDefault(require("lodash/pick"));

var _kebabCase2 = _interopRequireDefault(require("lodash/kebabCase"));

var _uniq2 = _interopRequireDefault(require("lodash/uniq"));

var _remove2 = _interopRequireDefault(require("lodash/remove"));

var _isUndefined2 = _interopRequireDefault(require("lodash/isUndefined"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _rsuiteIntl = require("rsuite-intl");

var _OverlayTrigger = _interopRequireDefault(require("rsuite-utils/lib/Overlay/OverlayTrigger"));

var _utils = require("rsuite-utils/lib/utils");

var _reactLifecyclesCompat = require("react-lifecycles-compat");

var _utils2 = require("../utils");

var _stringToObject = _interopRequireDefault(require("../utils/stringToObject"));

var _findNodesOfTree = _interopRequireDefault(require("../utils/findNodesOfTree"));

var _DropdownMenu = _interopRequireDefault(require("./DropdownMenu"));

var _PickerToggle = _interopRequireDefault(require("../_picker/PickerToggle"));

var _MenuWrapper = _interopRequireDefault(require("../_picker/MenuWrapper"));

var _getToggleWrapperClassName = _interopRequireDefault(require("../_picker/getToggleWrapperClassName"));

var _getDerivedStateForCascade = _interopRequireDefault(require("./getDerivedStateForCascade"));

/**
 * 获取一个节点的所有子节点的值
 */
function getChildrenValue(item, childrenKey, valueKey, uncheckableItemValues) {
  var values = [];

  if (!item[childrenKey]) {
    return values;
  }

  item[childrenKey].forEach(function (n) {
    if (!uncheckableItemValues.some(function (v) {
      return v === n[valueKey];
    })) {
      values.push(n[valueKey]);
    }

    values = values.concat(getChildrenValue(n, childrenKey, valueKey, uncheckableItemValues));
  });
  return values;
}
/**
 * 获取一个节点的所有父辈节点
 */


function getParents(item, uncheckableItemValues) {
  var parents = [];

  if (!item.parent) {
    return parents;
  }

  parents.push(item.parent);
  parents = parents.concat(getParents(item.parent));
  return parents;
}

var Dropdown =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(Dropdown, _React$Component);

  function Dropdown(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleCheck", function (item, event, checked) {
      var _this$props = _this.props,
          valueKey = _this$props.valueKey,
          onChange = _this$props.onChange,
          cascade = _this$props.cascade;
      var itemValue = item[valueKey];
      var value = [];

      if (cascade) {
        value = _this.getCheckedItemsByCascade(item, checked);
      } else {
        value = _this.getValue();

        if (checked) {
          value.push(itemValue);
        } else {
          value = value.filter(function (n) {
            return !(0, _utils.shallowEqual)(n, itemValue);
          });
        }
      }

      _this.setState({
        value: value
      });

      onChange && onChange(value, event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleSelect", function (node, cascadeItems, activePaths, event) {
      var onSelect = _this.props.onSelect;
      onSelect && onSelect(node, activePaths, event);

      _this.setState({
        selectNode: node,
        items: cascadeItems,
        tempActivePaths: activePaths
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "trigger", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindTriggerRef", function (ref) {
      _this.trigger = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "menuContainer", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindMenuContainerRef", function (ref) {
      _this.menuContainer = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "container", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindContainerRef", function (ref) {
      _this.container = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "closeDropdown", function () {
      if (_this.trigger) {
        _this.trigger.hide();
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleClean", function (event) {
      var _this$props2 = _this.props,
          disabled = _this$props2.disabled,
          onChange = _this$props2.onChange;

      if (disabled) {
        return;
      }

      var nextState = {
        value: null,
        activePaths: []
      };

      _this.setState(nextState, function () {
        onChange && onChange(null, event);
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleEntered", function () {
      var onOpen = _this.props.onOpen;
      onOpen && onOpen();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleExited", function () {
      var onClose = _this.props.onClose;
      onClose && onClose();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "addPrefix", function (name) {
      return (0, _utils2.prefix)(_this.props.classPrefix)(name);
    });
    var initState = {
      selectNode: null,
      data: props.data,
      value: props.defaultValue,

      /**
       * 选中值的路径
       */
      activePaths: [],

      /**
       * 用于展示面板的数据列表，是一个二维的数组
       * 是通过 data 树结构转换成的二维的数组，其中只包含页面上展示的数据
       */
      items: []
    };
    _this.state = (0, _extends2.default)({}, initState, (0, _getDerivedStateForCascade.default)(props, initState));
    return _this;
  }

  Dropdown.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    var data = nextProps.data,
        labelKey = nextProps.labelKey,
        valueKey = nextProps.valueKey,
        childrenKey = nextProps.childrenKey,
        cascade = nextProps.cascade,
        uncheckableItemValues = nextProps.uncheckableItemValues;
    var value = nextProps.value || prevState.value || [];

    if (!(0, _utils.shallowEqualArray)(data, prevState.data)) {
      /**
       * 如果更新了 data,
       * 首先获取到被点击节点的值 `selectNodeValue`， 然后再拿到新增后的 `newChildren`,
       */
      var selectNodeValue = (0, _get2.default)(prevState, ['selectNode', valueKey]);
      var newChildren = ((0, _get2.default)((0, _utils.findNodeOfTree)(data, function (item) {
        return (0, _utils.shallowEqual)(item[valueKey], selectNodeValue);
      }), 'children') || []).map(function (item) {
        return (0, _extends2.default)({}, (0, _stringToObject.default)(item, labelKey, valueKey), {
          parent: prevState.selectNode
        });
      });
      var nextState = (0, _getDerivedStateForCascade.default)(nextProps, prevState, selectNodeValue, newChildren);
      /**
       * 在级联的情况下，需要判断当前节点是否被选中，并更新子节点
       */

      if (cascade && value.some(function (n) {
        return n === selectNodeValue;
      })) {
        var _getChildrenValue;

        value = value.concat(getChildrenValue((_getChildrenValue = {}, _getChildrenValue[childrenKey] = newChildren, _getChildrenValue), childrenKey, valueKey, uncheckableItemValues));
      }

      return (0, _extends2.default)({}, nextState, {
        data: data,
        value: value
      });
    }

    return null;
  };

  var _proto = Dropdown.prototype;

  _proto.getValue = function getValue(nextProps) {
    var value = this.props.value;
    var nextValue = (0, _isUndefined2.default)(value) ? this.state.value : value;
    return nextValue ? nextValue.concat() : [];
  }; // 获取所有级联的节点


  _proto.getCheckedItemsByCascade = function getCheckedItemsByCascade(item, checked) {
    var _this$props3 = this.props,
        valueKey = _this$props3.valueKey,
        childrenKey = _this$props3.childrenKey,
        uncheckableItemValues = _this$props3.uncheckableItemValues;
    var itemValue = item[valueKey];
    var value = this.getValue();
    var childrenValue = getChildrenValue(item, childrenKey, valueKey, uncheckableItemValues);
    var parents = getParents(item);

    if (checked) {
      value.push(itemValue);
      value = value.concat(childrenValue);
      /**
       * 遍历当前节点所有祖宗节点
       * 然后判断这些节点的子节点是否是否全部被选中，则自身也要被选中
       */

      for (var i = 0, isContinue = true; i < parents.length && isContinue; i++) {
        var isCheckAll = parents[i][childrenKey] // 过滤掉被标识为不可选的选项
        .filter(function (n) {
          return !uncheckableItemValues.some(function (v) {
            return v === n[valueKey];
          });
        }) // 检查是否所有节点都被选中
        .every(function (n) {
          return value.some(function (v) {
            return v === n[valueKey];
          });
        });

        if (isCheckAll) {
          value.push(parents[i][valueKey]);
        } else {
          /**
           * 如果 parents[i] 下的子节点没有全选，
           * 那它祖宗节点肯定不会被选中，则没必要再继续循环。
           */
          isContinue = false;
        }
      }
    } else {
      value = value.filter(function (n) {
        return !(0, _utils.shallowEqual)(n, itemValue);
      });
      var tempValue = childrenValue.concat(parents.map(function (item) {
        return item[valueKey];
      })); // 删除相关的子父节点

      (0, _remove2.default)(value, function (item) {
        return tempValue.some(function (n) {
          return n === item;
        });
      });
    }

    return (0, _uniq2.default)(value);
  };

  _proto.renderDropdownMenu = function renderDropdownMenu() {
    var _this$state = this.state,
        items = _this$state.items,
        tempActivePaths = _this$state.tempActivePaths,
        activePaths = _this$state.activePaths;
    var _this$props4 = this.props,
        renderMenu = _this$props4.renderMenu,
        placement = _this$props4.placement,
        renderExtraFooter = _this$props4.renderExtraFooter,
        menuClassName = _this$props4.menuClassName,
        menuStyle = _this$props4.menuStyle,
        classPrefix = _this$props4.classPrefix;
    var classes = (0, _classnames.default)(this.addPrefix('cascader-menu'), this.addPrefix("placement-" + (0, _kebabCase2.default)(placement)), menuClassName);
    var menuProps = (0, _pick2.default)(this.props, _DropdownMenu.default.handledProps);
    return React.createElement(_MenuWrapper.default, {
      className: classes,
      style: menuStyle
    }, React.createElement(_DropdownMenu.default, (0, _extends2.default)({}, menuProps, {
      classPrefix: classPrefix,
      ref: this.bindMenuContainerRef,
      cascadeItems: items,
      cascadePathItems: tempActivePaths || activePaths,
      value: this.getValue(),
      onSelect: this.handleSelect,
      onCheck: this.handleCheck,
      renderMenu: renderMenu
    })), renderExtraFooter && renderExtraFooter());
  };

  _proto.render = function render() {
    var _this$props5 = this.props,
        data = _this$props5.data,
        valueKey = _this$props5.valueKey,
        labelKey = _this$props5.labelKey,
        className = _this$props5.className,
        placeholder = _this$props5.placeholder,
        renderValue = _this$props5.renderValue,
        disabled = _this$props5.disabled,
        cleanable = _this$props5.cleanable,
        locale = _this$props5.locale,
        open = _this$props5.open,
        defaultOpen = _this$props5.defaultOpen,
        onClose = _this$props5.onClose,
        placement = _this$props5.placement,
        classPrefix = _this$props5.classPrefix,
        toggleComponentClass = _this$props5.toggleComponentClass,
        block = _this$props5.block,
        style = _this$props5.style,
        container = _this$props5.container,
        containerPadding = _this$props5.containerPadding,
        onEnter = _this$props5.onEnter,
        onEntering = _this$props5.onEntering,
        onEntered = _this$props5.onEntered,
        onExit = _this$props5.onExit,
        onExiting = _this$props5.onExiting,
        onExited = _this$props5.onExited,
        onHide = _this$props5.onHide,
        appearance = _this$props5.appearance,
        rest = (0, _objectWithoutPropertiesLoose2.default)(_this$props5, ["data", "valueKey", "labelKey", "className", "placeholder", "renderValue", "disabled", "cleanable", "locale", "open", "defaultOpen", "onClose", "placement", "classPrefix", "toggleComponentClass", "block", "style", "container", "containerPadding", "onEnter", "onEntering", "onEntered", "onExit", "onExiting", "onExited", "onHide", "appearance"]);
    var activePaths = this.state.activePaths;
    var unhandled = (0, _utils2.getUnhandledProps)(Dropdown, rest);
    var value = this.getValue();
    var hasValue = !!value.length;
    var activeItemLabel = placeholder;

    if (renderValue) {
      var _selectedItems = (0, _findNodesOfTree.default)(data, function (item) {
        return value.some(function (v) {
          return v === item[valueKey];
        });
      }) || [];

      activeItemLabel = renderValue(value, _selectedItems);
    } else if (value.length > 0) {
      activeItemLabel = (0, _utils2.tplTransform)(locale.selectedValues, value.length);
    }

    var classes = (0, _getToggleWrapperClassName.default)('cascader', this.addPrefix, this.props, hasValue);
    return React.createElement(_rsuiteIntl.IntlProvider, {
      locale: locale
    }, React.createElement("div", {
      className: classes,
      style: style,
      tabIndex: -1,
      role: "menu",
      ref: this.bindContainerRef
    }, React.createElement(_OverlayTrigger.default, {
      ref: this.bindTriggerRef,
      open: open,
      defaultOpen: defaultOpen,
      disabled: disabled,
      trigger: "click",
      placement: placement,
      onEnter: (0, _utils2.createChainedFunction)(this.handleEntered, onEnter),
      onEntering: onEntering,
      onEntered: onEntered,
      onExit: onExit,
      onExiting: onExiting,
      onExited: (0, _utils2.createChainedFunction)(this.handleExited, onExited),
      onHide: onHide,
      speaker: this.renderDropdownMenu(),
      container: container,
      containerPadding: containerPadding
    }, React.createElement(_PickerToggle.default, (0, _extends2.default)({}, unhandled, {
      componentClass: toggleComponentClass,
      onClean: this.handleClean,
      cleanable: cleanable && !disabled,
      hasValue: hasValue
    }), activeItemLabel || React.createElement(_rsuiteIntl.FormattedMessage, {
      id: "placeholder"
    })))));
  };

  return Dropdown;
}(React.Component);

(0, _defineProperty2.default)(Dropdown, "defaultProps", {
  cascade: true,
  appearance: 'default',
  data: [],
  disabledItemValues: [],
  uncheckableItemValues: [],
  childrenKey: 'children',
  valueKey: 'value',
  labelKey: 'label',
  locale: {
    placeholder: 'Select',
    selectedValues: '{0} selected'
  },
  cleanable: true,
  placement: 'bottomLeft'
});
(0, _defineProperty2.default)(Dropdown, "handledProps", ["appearance", "block", "cascade", "childrenKey", "className", "classPrefix", "cleanable", "container", "containerPadding", "data", "defaultOpen", "defaultValue", "disabled", "disabledItemValues", "labelKey", "locale", "menuClassName", "menuHeight", "menuStyle", "menuWidth", "onChange", "onClose", "onEnter", "onEntered", "onEntering", "onExit", "onExited", "onExiting", "onHide", "onOpen", "onSelect", "open", "placeholder", "placement", "renderExtraFooter", "renderMenu", "renderMenuItem", "renderValue", "style", "toggleComponentClass", "uncheckableItemValues", "value", "valueKey"]);
(0, _reactLifecyclesCompat.polyfill)(Dropdown);
var enhance = (0, _utils2.defaultProps)({
  classPrefix: 'picker'
});

var _default = enhance(Dropdown);

exports.default = _default;