"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _isNumber2 = _interopRequireDefault(require("lodash/isNumber"));

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _kebabCase2 = _interopRequireDefault(require("lodash/kebabCase"));

var _trim2 = _interopRequireDefault(require("lodash/trim"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _isUndefined2 = _interopRequireDefault(require("lodash/isUndefined"));

var _isArray2 = _interopRequireDefault(require("lodash/isArray"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactDom = require("react-dom");

var _domLib = require("dom-lib");

var _rsuiteIntl = require("rsuite-intl");

var _reactLifecyclesCompat = require("react-lifecycles-compat");

var _OverlayTrigger = _interopRequireDefault(require("rsuite-utils/lib/Overlay/OverlayTrigger"));

var _utils = require("rsuite-utils/lib/utils");

var _TreeNode = _interopRequireDefault(require("./TreeNode"));

var _utils2 = require("../utils");

var _PickerToggle = _interopRequireDefault(require("../_picker/PickerToggle"));

var _MenuWrapper = _interopRequireDefault(require("../_picker/MenuWrapper"));

var _SearchBar = _interopRequireDefault(require("../_picker/SearchBar"));

var _getToggleWrapperClassName = _interopRequireDefault(require("../_picker/getToggleWrapperClassName"));

var _onMenuKeyDown = _interopRequireDefault(require("../_picker/onMenuKeyDown"));

var Tree =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(Tree, _React$Component);

  function Tree(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getFocusableMenuItems", function () {
      var filterData = _this.state.filterData;
      var _this$props = _this.props,
          childrenKey = _this$props.childrenKey,
          _this$props$disabledI = _this$props.disabledItemValues,
          disabledItemValues = _this$props$disabledI === void 0 ? [] : _this$props$disabledI,
          valueKey = _this$props.valueKey;
      var items = [];

      var loop = function loop(nodes) {
        nodes.forEach(function (node) {
          var disabled = disabledItemValues.filter(function (disabledItem) {
            return (0, _utils.shallowEqual)(disabledItem, node[valueKey]);
          }).length > 0;

          if (!disabled) {
            items.push(node);

            if (!node.expand) {
              return;
            }

            if (node[childrenKey]) {
              loop(node[childrenKey]);
            }
          }
        });
      };

      loop(filterData);
      return items;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getElementByDataKey", function (dataKey) {
      var ele = (0, _reactDom.findDOMNode)(_this.nodeRefs[dataKey]);

      if (ele instanceof Element) {
        return ele.querySelector("." + _this.addPrefix('tree-view-node-label'));
      }

      return null;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "nodes", {});
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "node", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "isControlled", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "tempNode", []);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "treeView", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindTreeViewRef", function (ref) {
      _this.treeView = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "trigger", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindTriggerRef", function (ref) {
      _this.trigger = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "container", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindContainerRef", function (ref) {
      _this.container = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "nodeRefs", {});
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindNodeRefs", function (refKey, ref) {
      _this.nodeRefs[refKey] = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "menu", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindMenuRef", function (ref) {
      _this.menu = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "selectActiveItem", function (event) {
      var _this$getActiveItem = _this.getActiveItem(),
          nodeData = _this$getActiveItem.nodeData,
          layer = _this$getActiveItem.layer;

      _this.handleSelect(nodeData, +layer, event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "focusNextItem", function () {
      var _this$getItemsAndActi = _this.getItemsAndActiveIndex(),
          items = _this$getItemsAndActi.items,
          activeIndex = _this$getItemsAndActi.activeIndex;

      if (items.length === 0) {
        return;
      }

      var nextIndex = activeIndex === items.length - 1 ? 0 : activeIndex + 1;

      var node = _this.getElementByDataKey(items[nextIndex].refKey);

      if (node !== null) {
        node.focus();
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "focusPreviousItem", function () {
      var _this$getItemsAndActi2 = _this.getItemsAndActiveIndex(),
          items = _this$getItemsAndActi2.items,
          activeIndex = _this$getItemsAndActi2.activeIndex;

      if (items.length === 0) {
        return;
      }

      var prevIndex = activeIndex === 0 ? items.length - 1 : activeIndex - 1;
      prevIndex = prevIndex >= 0 ? prevIndex : 0;

      var node = _this.getElementByDataKey(items[prevIndex].refKey);

      if (node !== null) {
        node.focus();
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "closeDropdown", function () {
      if (_this.trigger) {
        _this.trigger.hide();
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "addPrefix", function (name) {
      return (0, _utils2.prefix)(_this.props.classPrefix)(name);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "shouldDisplay", function (label, searchKeyword) {
      if (searchKeyword === void 0) {
        searchKeyword = _this.state.searchWord;
      }

      if (!(0, _trim2.default)(searchKeyword)) {
        return true;
      }

      var keyword = searchKeyword.toLocaleLowerCase();

      if (typeof label === 'string') {
        return label.toLocaleLowerCase().indexOf(keyword) >= 0;
      } else if (React.isValidElement(label)) {
        var nodes = (0, _utils.reactToString)(label);
        return nodes.join('').toLocaleLowerCase().indexOf(keyword) >= 0;
      }

      return false;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleTreeToggle", function (nodeData, layer) {
      var _this$props2 = _this.props,
          _this$props2$classPre = _this$props2.classPrefix,
          classPrefix = _this$props2$classPre === void 0 ? '' : _this$props2$classPre,
          onExpand = _this$props2.onExpand;
      var openClass = classPrefix + "-tree-view-open";
      (0, _domLib.toggleClass)((0, _reactDom.findDOMNode)(_this.nodeRefs[nodeData.refKey]), openClass);
      nodeData.expand = (0, _domLib.hasClass)((0, _reactDom.findDOMNode)(_this.nodeRefs[nodeData.refKey]), openClass);
      _this.nodes[nodeData.refKey].expand = nodeData.expand;
      onExpand && onExpand(nodeData, layer);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleSelect", function (nodeData, layer, event) {
      var _this$props3 = _this.props,
          valueKey = _this$props3.valueKey,
          onChange = _this$props3.onChange,
          onSelect = _this$props3.onSelect;
      _this.node = nodeData;

      if (!_this.isControlled) {
        _this.setState({
          activeNode: nodeData,
          selectedValue: nodeData[valueKey]
        });
      }

      onChange && onChange(nodeData[valueKey]);
      onSelect && onSelect(nodeData, layer, event);

      _this.closeDropdown();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleKeyDown", function (event) {
      (0, _onMenuKeyDown.default)(event, {
        down: _this.focusNextItem,
        up: _this.focusPreviousItem,
        enter: _this.selectActiveItem
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleToggleKeyDown", function (event) {
      var classPrefix = _this.props.classPrefix;

      if (!_this.treeView) {
        return;
      }

      if (event.target instanceof HTMLElement) {
        var className = event.target.className;

        if (className.includes(classPrefix + "-toggle") || className.includes(classPrefix + "-toggle-custom") || className.includes(classPrefix + "-search-bar-input")) {
          (0, _onMenuKeyDown.default)(event, {
            down: _this.focusNextItem
          });
        }
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleSearch", function (value, event) {
      var filterData = _this.state.filterData;
      var _this$props4 = _this.props,
          onSearch = _this$props4.onSearch,
          data = _this$props4.data;

      _this.setState({
        searchWord: value,
        filterData: _this.getFilterData(filterData, value)
      });

      onSearch && onSearch(value, event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleClean", function () {
      var onChange = _this.props.onChange;

      _this.setState({
        activeNode: null,
        selectedValue: null
      });

      _this.node = null;
      onChange && onChange(null);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleOnOpen", function () {
      var activeNode = _this.state.activeNode;
      var onOpen = _this.props.onOpen;

      if (activeNode) {
        var node = _this.getElementByDataKey(activeNode.refKey);

        if (node !== null) {
          node.focus();
        }
      }

      onOpen && onOpen();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleOnClose", function () {
      var onClose = _this.props.onClose;
      onClose && onClose();
    });
    _this.isControlled = 'value' in props;
    var _data = props.data,
        _valueKey = props.valueKey;
    var nextData = (0, _utils2.clone)(_data);

    _this.flattenNodes(nextData);

    _this.state = {
      data: props.data,
      value: props.value,
      selectedValue: _this.getValue(props),
      expandAll: _this.getExpandAll(props),
      filterData: _this.getFilterData(nextData, props.searchKeyword, props),
      activeNode: _this.getActiveNode(_this.getValue(props), _valueKey),
      searchWord: props.searchKeyword || '',
      searchKeyword: props.searchKeyword || ''
    };
    return _this;
  }

  var _proto = Tree.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var activeNode = this.state.activeNode;
    this.focusNode(activeNode);
  };

  Tree.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    var value = nextProps.value,
        data = nextProps.data,
        expandAll = nextProps.expandAll,
        valueKey = nextProps.valueKey,
        searchKeyword = nextProps.searchKeyword;
    var nextState = {};

    if ((0, _isArray2.default)(data) && (0, _isArray2.default)(prevState.data) && !(0, _utils.shallowEqualArray)(prevState.data, data)) {
      nextState.data = data;
    }

    if (!(0, _utils.shallowEqual)(value, prevState.value)) {
      nextState.value = value;
      nextState.selectedValue = value;
    }

    if (prevState.searchKeyword !== searchKeyword) {
      nextState.searchWord = searchKeyword;
    }

    if (expandAll !== prevState.expandAll) {
      nextState.expandAll = expandAll;
    }

    return Object.keys(nextState).length ? nextState : null;
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    var _this$state = this.state,
        filterData = _this$state.filterData,
        searchWord = _this$state.searchWord,
        selectedValue = _this$state.selectedValue;
    var _this$props5 = this.props,
        value = _this$props5.value,
        data = _this$props5.data,
        expandAll = _this$props5.expandAll,
        valueKey = _this$props5.valueKey,
        searchKeyword = _this$props5.searchKeyword;

    if (!(0, _utils.shallowEqualArray)(prevState.data, data)) {
      var nextData = (0, _utils2.clone)(data);
      this.flattenNodes(nextData);

      var _filterData = this.getFilterData(nextData, searchWord);

      var _activeNode = this.getActiveNode(this.getValue());

      this.focusNode(_activeNode);
      this.setState({
        data: nextData,
        filterData: _filterData,
        activeNode: _activeNode
      });
    }

    if (!(0, _utils.shallowEqual)(prevState.value, value)) {
      var _activeNode2 = null;

      if (this.node === null) {
        _activeNode2 = this.getActiveNode(value);
      }

      if (value !== null && this.node !== null) {
        _activeNode2 = (0, _utils.shallowEqual)(this.node[valueKey], value) ? this.node : this.getActiveNode(value);
      }

      var nextState = {
        value: value,
        activeNode: _activeNode2
      };

      if (value === null) {
        nextState.activeNode = null;
        this.node = null;
      }

      if (_activeNode2 !== null) {
        this.focusNode(_activeNode2);
      }

      this.setState(nextState);
    }

    if (prevProps.searchKeyword !== this.props.searchKeyword) {
      this.setState({
        filterData: this.getFilterData(filterData, searchKeyword),
        searchWord: searchKeyword
      });
    }
  };

  _proto.getExpandAll = function getExpandAll(props) {
    if (props === void 0) {
      props = this.props;
    }

    return props.expandAll !== undefined ? props.expandAll : props.defaultExpandAll;
  };

  _proto.getValue = function getValue(props) {
    if (props === void 0) {
      props = this.props;
    }

    var _props = props,
        value = _props.value,
        defaultValue = _props.defaultValue;
    return !(0, _isUndefined2.default)(value) ? value : defaultValue;
  };

  _proto.getActiveNode = function getActiveNode(value, valueKey) {
    var _this2 = this;

    if (valueKey === void 0) {
      valueKey = this.props.valueKey;
    }

    var activeNode = null;

    if (!(0, _isUndefined2.default)(value)) {
      Object.keys(this.nodes).forEach(function (refKey) {
        if ((0, _utils.shallowEqual)(_this2.nodes[refKey][valueKey], value)) {
          activeNode = _this2.nodes[refKey];
        }
      });
    }

    return activeNode;
  };

  _proto.getExpandState = function getExpandState(node, props) {
    if (props === void 0) {
      props = this.props;
    }

    var expandAll = this.getExpandAll(props);
    var _props2 = props,
        childrenKey = _props2.childrenKey;

    if (node[childrenKey] && node[childrenKey].length) {
      if ('expand' in node) {
        return !!node.expand;
      } else if (expandAll) {
        return true;
      }

      return false;
    }

    return false;
  };

  _proto.getActiveElementOption = function getActiveElementOption(options, value) {
    for (var i = 0; i < options.length; i += 1) {
      if (options[i].value === value) {
        return options[i];
      } else if (options[i].children && options[i].children.length) {
        var active = this.getActiveElementOption(options[i].children, value);

        if (!(0, _isEmpty2.default)(active)) {
          return active;
        }
      }
    }

    return {};
  };

  _proto.getItemsAndActiveIndex = function getItemsAndActiveIndex() {
    var items = this.getFocusableMenuItems();
    var activeIndex = -1;
    items.forEach(function (item, index) {
      if (document.activeElement !== null) {
        if (item.refKey === document.activeElement.getAttribute('data-key')) {
          activeIndex = index;
        }
      }
    });
    return {
      items: items,
      activeIndex: activeIndex
    };
  };

  _proto.getActiveItem = function getActiveItem() {
    var nodeData = {};

    if (document.activeElement !== null) {
      var activeItem = document.activeElement;
      var _activeItem$dataset = activeItem.dataset,
          key = _activeItem$dataset.key,
          _layer = _activeItem$dataset.layer;
      var _activeNode3 = this.nodes[key];

      if (_activeNode3) {
        nodeData = _activeNode3;
      }

      return {
        nodeData: nodeData,
        layer: _layer
      };
    }

    return {};
  };

  _proto.getFilterData = function getFilterData(data, word, props) {
    var _this3 = this;

    if (props === void 0) {
      props = this.props;
    }

    var _props3 = props,
        labelKey = _props3.labelKey;

    var setVisible = function setVisible(nodes) {
      if (nodes === void 0) {
        nodes = [];
      }

      return nodes.forEach(function (item) {
        item.visible = _this3.shouldDisplay(item[labelKey], word);

        if ((0, _isArray2.default)(item.children)) {
          setVisible(item.children);
          item.children.forEach(function (child) {
            if (child.visible) {
              item.visible = child.visible;
            }
          });
        }
      });
    };

    if (!(0, _isUndefined2.default)(word) || !word !== '') {
      setVisible(data);
    }

    return data;
  };

  _proto.focusNode = function focusNode(activeNode) {
    var inline = this.props.inline;

    if (activeNode && inline) {
      var node = this.getElementByDataKey(activeNode.refKey);

      if (node !== null) {
        node.focus();
      }
    }
  };
  /**
   * 将数组变为对象
   * @param {*} nodes tree data
   * @param {*} ref 当前层级
   */


  _proto.flattenNodes = function flattenNodes(nodes, props, ref, parentNode) {
    var _this4 = this;

    if (props === void 0) {
      props = this.props;
    }

    if (ref === void 0) {
      ref = '0';
    }

    var _props4 = props,
        labelKey = _props4.labelKey,
        valueKey = _props4.valueKey,
        childrenKey = _props4.childrenKey;

    if (!Array.isArray(nodes) || nodes.length === 0) {
      return [];
    }

    nodes.map(function (node, index) {
      var _this4$nodes$refKey;

      var refKey = ref + "-" + index;
      node.refKey = refKey;
      node.expand = _this4.getExpandState(node, props);
      _this4.nodes[refKey] = (_this4$nodes$refKey = {}, _this4$nodes$refKey[labelKey] = node[labelKey], _this4$nodes$refKey[valueKey] = node[valueKey], _this4$nodes$refKey.expand = node.expand, _this4$nodes$refKey.refKey = refKey, _this4$nodes$refKey);

      if (parentNode) {
        _this4.nodes[refKey].parentNode = parentNode;
      }

      _this4.flattenNodes(node[childrenKey], props, refKey, _this4.nodes[refKey]);
    });
  };

  _proto.renderDropdownMenu = function renderDropdownMenu() {
    var _this$props6 = this.props,
        searchable = _this$props6.searchable,
        placement = _this$props6.placement,
        renderExtraFooter = _this$props6.renderExtraFooter,
        locale = _this$props6.locale,
        renderMenu = _this$props6.renderMenu,
        menuStyle = _this$props6.menuStyle,
        menuClassName = _this$props6.menuClassName;
    var classes = (0, _classnames.default)(menuClassName, this.addPrefix('tree-menu'), this.addPrefix("placement-" + (0, _kebabCase2.default)(placement)));
    return React.createElement(_MenuWrapper.default, {
      className: classes,
      style: menuStyle,
      ref: this.bindMenuRef
    }, searchable ? React.createElement(_SearchBar.default, {
      placeholder: locale.searchPlaceholder,
      key: "searchBar",
      onChange: this.handleSearch,
      value: this.state.searchWord
    }) : null, renderMenu ? renderMenu(this.renderTree()) : this.renderTree(), renderExtraFooter && renderExtraFooter());
  };

  _proto.renderNode = function renderNode(node, index, layer, classPrefix) {
    var _this5 = this;

    if (!node.visible) {
      return null;
    }

    var _this$state2 = this.state,
        expandAll = _this$state2.expandAll,
        selectedValue = _this$state2.selectedValue;
    var _this$props7 = this.props,
        _this$props7$disabled = _this$props7.disabledItemValues,
        disabledItemValues = _this$props7$disabled === void 0 ? [] : _this$props7$disabled,
        valueKey = _this$props7.valueKey,
        labelKey = _this$props7.labelKey,
        childrenKey = _this$props7.childrenKey,
        renderTreeNode = _this$props7.renderTreeNode,
        renderTreeIcon = _this$props7.renderTreeIcon;
    var refKey = node.refKey;
    var key = (0, _isString2.default)(node[valueKey]) || (0, _isNumber2.default)(node[valueKey]) ? node[valueKey] : refKey;
    var hasChildren = node.hasChildren;
    var children = node[childrenKey];
    var hasNotEmptyChildren = hasChildren !== undefined ? hasChildren : children && Array.isArray(children) && children.length > 0;
    var props = {
      value: node[valueKey],
      label: node[labelKey],
      index: index,
      layer: layer,
      parent: parent,
      active: (0, _utils.shallowEqual)(node[valueKey], selectedValue),
      visible: node.visible,
      children: children,
      nodeData: node,
      disabled: disabledItemValues.filter(function (disabledItem) {
        return (0, _utils.shallowEqual)(disabledItem, node[valueKey]);
      }).length > 0,
      hasChildren: !!children,
      onSelect: this.handleSelect,
      onTreeToggle: this.handleTreeToggle,
      onRenderTreeNode: renderTreeNode,
      onRenderTreeIcon: renderTreeIcon
    };

    if (props.hasChildren) {
      var _classNames;

      layer += 1;
      var expandControlled = 'expandAll' in this.props;
      var expandALlState = expandControlled ? expandAll : expandAll || this.nodes[node.refKey].expand; // 是否展开树节点且子节点不为空

      var openClass = classPrefix + "-open";
      var childrenClass = (0, _classnames.default)(classPrefix + "-node-children", (_classNames = {}, _classNames[openClass] = expandALlState && hasNotEmptyChildren, _classNames));
      var nodes = children || [];
      return React.createElement("div", {
        className: childrenClass,
        key: key,
        ref: this.bindNodeRefs.bind(this, refKey)
      }, React.createElement(_TreeNode.default, (0, _extends2.default)({
        classPrefix: classPrefix,
        key: key,
        ref: this.bindNodeRefs.bind(this, refKey)
      }, props)), React.createElement("div", {
        className: classPrefix + "-children"
      }, nodes.map(function (child, i) {
        return _this5.renderNode(child, i, layer, classPrefix);
      })));
    }

    return React.createElement(_TreeNode.default, (0, _extends2.default)({
      classPrefix: classPrefix,
      key: key,
      ref: this.bindNodeRefs.bind(this, refKey)
    }, props));
  };

  _proto.renderTree = function renderTree() {
    var _classNames2,
        _this6 = this;

    var filterData = this.state.filterData;
    var _this$props8 = this.props,
        height = _this$props8.height,
        _this$props8$classNam = _this$props8.className,
        className = _this$props8$classNam === void 0 ? '' : _this$props8$classNam,
        inline = _this$props8.inline,
        locale = _this$props8.locale; // 树节点的层级

    var layer = 0;
    var treeViewClasses = this.addPrefix('tree-view');
    var classes = (0, _classnames.default)(treeViewClasses, (_classNames2 = {}, _classNames2[className] = inline, _classNames2));
    var nodes = filterData.map(function (dataItem, index) {
      return _this6.renderNode(dataItem, index, layer, treeViewClasses);
    });

    if (!nodes.some(function (v) {
      return v !== null;
    })) {
      return React.createElement("div", {
        className: this.addPrefix('none')
      }, locale.noResultsText);
    }

    var style = inline ? this.props.style : {};
    var styles = (0, _extends2.default)({
      height: height
    }, style);
    return React.createElement("div", {
      ref: this.bindTreeViewRef,
      className: classes,
      style: styles,
      onKeyDown: this.handleKeyDown
    }, React.createElement("div", {
      className: this.addPrefix('tree-view-nodes')
    }, nodes));
  };

  _proto.render = function render() {
    var _this$props9 = this.props,
        inline = _this$props9.inline,
        locale = _this$props9.locale,
        open = _this$props9.open,
        defaultOpen = _this$props9.defaultOpen,
        disabled = _this$props9.disabled,
        className = _this$props9.className,
        toggleComponentClass = _this$props9.toggleComponentClass,
        placement = _this$props9.placement,
        classPrefix = _this$props9.classPrefix,
        placeholder = _this$props9.placeholder,
        cleanable = _this$props9.cleanable,
        renderValue = _this$props9.renderValue,
        valueKey = _this$props9.valueKey,
        labelKey = _this$props9.labelKey,
        appearance = _this$props9.appearance,
        onOpen = _this$props9.onOpen,
        onClose = _this$props9.onClose,
        onHide = _this$props9.onHide,
        container = _this$props9.container,
        containerPadding = _this$props9.containerPadding,
        onEnter = _this$props9.onEnter,
        onEntering = _this$props9.onEntering,
        onEntered = _this$props9.onEntered,
        onExit = _this$props9.onExit,
        onExiting = _this$props9.onExiting,
        onExited = _this$props9.onExited,
        block = _this$props9.block,
        style = _this$props9.style,
        rest = (0, _objectWithoutPropertiesLoose2.default)(_this$props9, ["inline", "locale", "open", "defaultOpen", "disabled", "className", "toggleComponentClass", "placement", "classPrefix", "placeholder", "cleanable", "renderValue", "valueKey", "labelKey", "appearance", "onOpen", "onClose", "onHide", "container", "containerPadding", "onEnter", "onEntering", "onEntered", "onExit", "onExiting", "onExited", "block", "style"]);
    var activeNode = this.state.activeNode;
    var classes = (0, _getToggleWrapperClassName.default)('tree', this.addPrefix, this.props, !!activeNode);
    var placeholderText = null;
    var hasValue = activeNode !== null;

    if (hasValue) {
      placeholderText = activeNode && activeNode[labelKey];
    } else if (placeholder) {
      placeholderText = placeholder;
    }

    if (renderValue && hasValue) {
      placeholderText = renderValue(activeNode, placeholderText);
    }

    var unhandled = (0, _utils2.getUnhandledProps)(Tree, rest);
    return !inline ? React.createElement(_rsuiteIntl.IntlProvider, {
      locale: locale
    }, React.createElement("div", {
      className: classes,
      style: style,
      onKeyDown: this.handleToggleKeyDown,
      tabIndex: -1,
      role: "menu",
      ref: this.bindContainerRef
    }, React.createElement(_OverlayTrigger.default, {
      ref: this.bindTriggerRef,
      open: open,
      defaultOpen: defaultOpen,
      disabled: disabled,
      trigger: "click",
      placement: placement,
      onEnter: onEnter,
      onEntering: onEntering,
      onEntered: (0, _utils2.createChainedFunction)(this.handleOnOpen, onEntered),
      onExit: onExit,
      onExiting: onExiting,
      onExited: (0, _utils2.createChainedFunction)(this.handleOnClose, onExited),
      onHide: onHide,
      container: container,
      containerPadding: containerPadding,
      speaker: this.renderDropdownMenu()
    }, React.createElement(_PickerToggle.default, (0, _extends2.default)({}, unhandled, {
      onClean: this.handleClean,
      cleanable: cleanable && !disabled,
      componentClass: toggleComponentClass,
      hasValue: hasValue
    }), placeholderText || React.createElement(_rsuiteIntl.FormattedMessage, {
      id: "placeholder"
    }))))) : this.renderTree();
  };

  return Tree;
}(React.Component);

(0, _defineProperty2.default)(Tree, "defaultProps", {
  locale: {
    placeholder: 'Select',
    searchPlaceholder: 'Search',
    selectedValues: '{0} selected',
    noResultsText: 'No results found'
  },
  valueKey: 'value',
  labelKey: 'label',
  cleanable: true,
  placement: 'bottomLeft',
  searchable: true,
  appearance: 'default',
  childrenKey: 'children',
  searchKeyword: ''
});
(0, _defineProperty2.default)(Tree, "handledProps", ["appearance", "block", "childrenKey", "className", "classPrefix", "cleanable", "container", "containerPadding", "data", "defaultExpandAll", "defaultOpen", "defaultValue", "disabled", "disabledItemValues", "expandAll", "height", "inline", "labelKey", "locale", "menuClassName", "menuStyle", "onChange", "onClose", "onEnter", "onEntered", "onEntering", "onExit", "onExited", "onExiting", "onExpand", "onHide", "onOpen", "onSearch", "onSelect", "open", "placeholder", "placement", "renderExtraFooter", "renderMenu", "renderTreeIcon", "renderTreeNode", "renderValue", "searchKeyword", "searchable", "style", "toggleComponentClass", "value", "valueKey"]);
(0, _reactLifecyclesCompat.polyfill)(Tree);
var enhance = (0, _utils2.defaultProps)({
  classPrefix: 'picker'
});

var _default = enhance(Tree);

exports.default = _default;