"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = disabledTime;
exports.calendarOnlyProps = void 0;

var _pick2 = _interopRequireDefault(require("lodash/pick"));

var calendarOnlyProps = ['disabledHours', 'disabledMinutes', 'disabledSeconds', 'hideHours', 'hideHours', 'hideMinutes', 'hideSeconds'];
exports.calendarOnlyProps = calendarOnlyProps;

function disabledTime(props, date) {
  if (!date) {
    return false;
  }

  var calendarProps = (0, _pick2.default)(props, calendarOnlyProps);
  return Object.keys(calendarProps).some(function (key) {
    if (/(Hours)/.test(key)) {
      return calendarProps[key](date.hours(), date);
    }

    if (/(Minutes)/.test(key)) {
      return calendarProps[key](date.minutes(), date);
    }

    if (/(Seconds)/.test(key)) {
      return calendarProps[key](date.seconds(), date);
    }

    return false;
  });
}